<?php
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
//////■ 以下スクリプト ■////
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
mb_language("japanese");
mb_internal_encoding("UTF-8");
//mb_detect_order("ASCII,JIS,UTF-8,EUC-JP,SJIS");

// 外部ファイル読み込み
$CSTM = array(); $PATH = array();
require_once('./config.php');
require_once('./jcode.php');

// アクセスチェック
//if ($_SERVER['REQUEST_METHOD'] != "POST") { return; }

// 機能設定取得
$CFGFILE = file($PATH['datadir'].$PATH['configdat']);
foreach ($CFGFILE as $line) {
	list($name, $value) = explode("=", rtrim($line, "\n"));
	$CSTM[$name] = $value;
}

// 処理分岐
if ($_POST['mode'] === 'clap_write') {
	clap_write();
} else if ($_POST['mode'] === 'message_write') {
	message_write();
} else {
	view();
}

exit;
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 拍手書き込み
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function clap_write() {
	global $CSTM, $PATH;

	$usid = $_POST['id'];

	// 半角英数チェック
	if (!preg_match("/^[\w\_\-]+$/", $usid)) return;

	// クッキーによる連続拍手制限
	if ($CSTM['cookiectrl'] == 1) {
		$ckchain = $_COOKIE['mwhm_'.$usid] + 1;
		if ($ckchain > $CSTM['chain']) {
			echo '_CLAPPING_OVER_';
			return;
		}
	}

	$ushost = get_host();

	// アクセス制限
	foreach (explode('<br />', $CSTM['denyhost']) as $host) {
		if ($host === '') continue;
		$denyhost = preg_replace("/\./", "\\.", $host);
		$denyhost = preg_replace("/\*/", "\.\*", $denyhost);
		if (preg_match("/$denyhost/i", $ushost)) return;
	}

	// ▼個別拍手保存ファイル書き込み
	$clapfile = $PATH['datadir'].$PATH['iddir'].$usid.'.dat';

	if (file_exists($clapfile)) {
		// 既存ファイルから書き込み
		$CFILE = file($clapfile);
		list($count, $evcnt, $evttl) = explode("\t", $CFILE[0]);

		$count++;
		if ($count > 3+2) return;

		$cline = "$count\t$evcnt\t$evttl";

		$FN = fopen($clapfile, "r+");
		flock($FN, LOCK_EX);
		fputs($FN, $cline);
		flock($FN, LOCK_UN);
		fclose($FN);
	} else {
		// 新規ファイルから書き込み
		$count = 1;

		$cline = "$count\t0\t0";

		$FN = fopen($clapfile, "w");
		fputs($FN, $cline);
		fclose($FN);
	}

	// ▼当日拍手保存ファイル書き込み
    //$newtime = time() + 9 * 60 * 60;
    $newtime = time();

	$clapdir = $PATH['datadir'].$PATH['datedir'].date("Y");

	if (!file_exists($clapdir)) {
		umask(0);
		mkdir($clapdir);
	}

	$dayfile = "$clapdir/".date("m-d").'.dat';

	if (file_exists($dayfile)) {
		// 既存ファイルから書き込み

		$DFILE = file($dayfile);

		for ($i = 0; $i < count($DFILE); $i++) {
			list($time, $id, $host, $chain, $name, $eval, $message) = explode("\t", $DFILE[$i]);

			if ($id === $usid && $host === $ushost) {

				$chainset = (isset($ckchain)) ? $ckchain : $chain + 1;

				// ホストチェックによる連続拍手制限
				if ($CSTM['hostctrl'] == 1 && $CSTM['chain'] > 0 && $chainset > $CSTM['chain']) {
					echo '_CLAPPING_OVER_';
					return;
				}

				$DFILE[$i] = "$time\t$id\t$ushost\t$chainset\t$name\t$eval\t$message";
				$flg = 1;
				break;
			}
		}
		if (empty($flg)) {
			$chainset = (isset($ckchain)) ? $ckchain : 1;
			array_push($DFILE, "$newtime\t$usid\t$ushost\t$chainset\t\t\t\n");
		}

		$FN = fopen($dayfile, "w");
		flock($FN, LOCK_EX);
		fputs($FN, implode('', $DFILE));
		flock($FN, LOCK_UN);
		fclose($FN);
	} else {
		// 新規ファイルから書き込み
		$chainset = (isset($ckchain)) ? $ckchain : 1;
		$FN = fopen($dayfile, "w");
		fputs($FN, "$newtime\t$usid\t$ushost\t$chainset\t\t\t\n");
		fclose($FN);
	}

	// クッキーセット
	if ($CSTM['cookiectrl'] == 1 || $CSTM['clapnum'] === 'myclap' || $CSTM['clapnum'] === 'total_myclap') {
		$chainset = ((isset($_COOKIE['mwhm_'.$usid])) ? $_COOKIE['mwhm_'.$usid] : 0) + 1;
		$timeout = time() + 60 * 60 * 24 * 30;
		setcookie('mwhm_'.$usid, $chainset, $timeout, '/', $_SERVER['SERVER_NAME']);
	}

	// 拍手数表示形式
	if ($CSTM['clapnum'] === 'myclap') {
		$html = '<span class="pdg"><span class="mwhm_clapcount">'. $chainset. '</span></span>';
	} else if ($CSTM['clapnum'] === 'total_myclap') {
		$html = '<span class="pdg"><span class="mwhm_clapcount">'. ($count - $chainset). '</span> + <span class="mwhm_clapcount">'. $chainset. '</span>';
	} else if ($CSTM['clapnum'] === 'total') {
		$html = '<span class="pdg"><span class="mwhm_clapcount">'. $count. '</span></span>';
	} else {
		$html = '<!--none-->';
	}

	@header('Content-Type: text/html; charset: utf-8');
	echo $html;
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ メッセージ書き込み
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function message_write() {
	global $CSTM, $PATH;

	$ushost = get_host();
	$usid = $_POST['id'];

	// ▼当日拍手保存ファイル書き込み
	$newname = decode($_POST['name']);
	$newmessage = decode($_POST['message']);
	$neweval = decode($_POST['eval']);

	$newname = ($newname === '名前') ? '' : $newname;
	if (!empty($_POST['tkbn'])) {
		$tkbn = decode($_POST['tkbn']);
		$newmessage = '<b>'.$tkbn.'</b><br />'.$newmessage;
	}

	//$message = JcodeConvert($message, 0, 4);
	//$newtime = time() + 9 * 60 * 60;
    $newtime = time();

	$clapdir = $PATH['datadir'].$PATH['datedir'].date("Y");

	if (!file_exists($clapdir)) {
		umask(0);
		mkdir($clapdir);
	}

	$dayfile = "$clapdir/".date("m-d").'.dat';

	if (file_exists($dayfile)) {
		// 既存ファイルから書き込み

		$DFILE = file($dayfile);

		for ($i = 0; $i < count($DFILE); $i++) {
			list($time, $id, $host, $chain, $name, $eval, $message) = explode("\t", rtrim($DFILE[$i], "\n"));

			if ($id === $usid && $host === $ushost) {
				if ($newname === "") $newname = $name;
				if ($neweval === "") $neweval = $eval;

				if ($message !== "") $newmessage = $message.'<br />'.$newmessage;

				$DFILE[$i] = "$time\t$id\t$ushost\t$chain\t$newname\t$neweval\t$newmessage\n";
				$flg = 1;
				break;
			}
		}
		if (empty($flg)) {
			$chainset = (isset($_COOKIE['mwhm_'.$usid])) ? $_COOKIE['mwhm_'.$usid] : 1;
			array_push($DFILE, "$newtime\t$usid\t$ushost\t$chainset\t$newname\t$neweval\t$newmessage\n");
		}

		$FN = fopen($dayfile, "w");
		flock($FN, LOCK_EX);
		fputs($FN, implode('', $DFILE));
		flock($FN, LOCK_UN);
		fclose($FN);
	} else {
		// 新規ファイルから書き込み
		$chainset = (isset($_COOKIE['mwhm_'.$usid])) ? $_COOKIE['mwhm_'.$usid] : 1;
		$FN = fopen($dayfile, "w");
		fputs($FN, "$newtime\t$usid\t$ushost\t$chainset\t$newname\t$neweval\t$newmessage\n");
		fclose($FN);
	}

	// ▼個別拍手保存ファイル書き込み
	if ($neweval !== '') {
		// 評価のみ書き換え
		$clapfile = $PATH['datadir'].$PATH['iddir'].$usid.'.dat';

		if (file_exists($clapfile)) {
			$CFILE = file($clapfile);
			list($count, $evcnt, $evttl) = explode("\t", $CFILE[0]);
			$evcnt++;
			$evttl += $neweval;
			$line = "$count\t$evcnt\t$evttl";

			$FN = fopen($clapfile, "r+");
			flock($FN, LOCK_EX);
			fputs($FN, $line);
			flock($FN, LOCK_UN);
			fclose($FN);
		}
	}

	// メール送信
	if (($CSTM['messsend'] == 1 && !empty($_POST['message']))
	or ($CSTM['tkbnsend'] == 1 && !empty($_POST['tkbn']))
	or ($CSTM['namesend'] == 1 && !empty($newname))
	or ($CSTM['evalsend'] == 1 && !empty($_POST['eval']))) {
		$to = $CSTM['mail'];
		$subject = "【拍手通知】メッセージがありました";
		$body .= "以下の内容で拍手メッセージが届きました。\n\n";
		$body .= "---------------------------------------\n";
		$body .= "【日付】". date("Y/m/d H:i"). "\n";
		if ($newname !== '') $body .= "【名前】". $newname."\n";
		if ($neweval !== '') $body .= "【評価】". $neweval. "\n";
		if ($tkbn !== '') $body .= "【定型文】". $tkbn. "\n";
		$body .= "【メッセージ】". mb_convert_encoding($_POST['message'], "JIS", "auto"). "\n";
		$body .= "---------------------------------------\n";
		$fromname = mb_encode_mimeheader("まいるどWEB拍手");
		$from = "From: ". $fromname. "<". $fromname. ">";

		mb_send_mail($to, $subject, $body, $from);
	}

	@header('Content-Type: text/html; charset: utf-8');
	echo '送信しました。';
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 拍手ボタン表示
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function view() {
	global $CSTM, $PATH, $version;

	// 未定義チェック
	if (empty($_GET['id'])) return;

	// 拍手数
	if ($CSTM['clapnum'] !== 'none') {
		// 個別拍手保存ファイル読み込み
		$clapfile = $PATH['datadir'].$PATH['iddir'].$_GET['id'].'.dat';
		if (file_exists($clapfile)) {
			$CFILE = file($clapfile);
			list($count, $evcnt, $evttl) = explode("\t", $CFILE[0]);

			// if (($evttl != 0) && ($evcnt != 0) && ($evcnt % $evttl == 0)) {
			$ave = (($evttl != 0) && ($evcnt != 0)) ? sprintf("%.1f", ($evttl / $evcnt)) : '0.0';
		} else {
			$count = 0;
			$ave = '0.0';
		}

		// 拍手数表示形式
		$myclap = $_COOKIE['mwhm_'.$_GET['id']];
		if ($CSTM['clapnum'] === 'myclap') {
			$count = ($myclap) ? $myclap : 0;
		} else if ($CSTM['clapnum'] === 'total_myclap') {
			$count -= (($count - $myclap) > 0) ? $myclap : $count;
			$count .= ($myclap) ? '</span> + <span class="mwhm_clapcount">'.$myclap : '';
		}
	}

	$imgdir = dirname('http://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI']).$PATH['imgdir'];

	// 星アイコン
	$starimg = $imgdir.$PATH['starimg'];
	$starimg2 = $imgdir.$PATH['starimg2'];
	$starimg3 = $imgdir.$PATH['starimg3'];

	$html = '<button class="mwhm_clapbutton" title="WEB拍手">';

		if ($CSTM['btntype'] === 'arrow') {
			$html .= '拍手</button>'.
					'<span id="count" class="mwhm_arrow"><span class="pdg"><span class="mwhm_clapcount">'. $count. '</span></span></span>';
		} else {
			$html .= '<span id="count"><span class="mwhm_clapcount">'. $count. '</span></span> 拍手</button>';
		}

		$html .= '<div id="message" class="mwhm_message">'.
					'<img src="" width="28" height="28" class="mwhm_close" alt="閉じる" title="閉じる">'.
					$CSTM['thanks'].'<br />';

					if ($CSTM['iptname'] == 1) {
						$html .= '<input type="text" value="名前" id="name" size="15" onfocus="this.value=\'\'" /> ';
					}

					if ($CSTM['iptrev'] == 1) {
						$html .= '<select id="eval"><option value="">評価</option>';
						for ($e = 1; $e <= 5; $e++) {
							$html .= '<option>'. $e. '</option>';
						}
						$html .= '<select>';
					}

					if ($CSTM['tkbnfunc'] == 1) {
						$html .= '<div><select id="tkbn"><option value="">定型文</option>';
						foreach (explode("<br />", $CSTM['tkbn']) as $line) {
							$html .= '<option>'. $line. '</option>';
						}
						$html .= '<select></div>';
					}

					if ($CSTM['iptmess'] == 1) {
						$html .= '<textarea rows="5" cols="40" id="txtbox" style="display: block;"></textarea>';
					}

					if ($CSTM['iptname'] == 1 || $CSTM['iptrev'] == 1 || $CSTM['tkbnfunc'] == 1 || $CSTM['iptmess'] == 1) {
					    $html .= '<input type="button" value="送信" class="mwhm_submit" />'.
								' <span style="color: #CC3333;" id="done"></span>';
					}

		$html .= '<div align="right"><small><a href="http://goo.gl/kxtdN" target="_blank">まいるどWEB拍手 '.$version.'</a></small></div>'.
				'</div>';

	if ($CSTM['iptrev'] == 1) {
		for ($i = 1; $i <= 5; $i++) {
			if ($i <= $ave) {
				$html .= '<img src="'.$starimg.'" width="11" height="11" />';
			} elseif (empty($flg) && ($ave - floor($ave)) >= 0.5) {
				$html .= '<img src="'.$starimg2.'" width="11" height="11" />';
				$flg = 1;
			} else {
				$html .= '<img src="'.$starimg3.'" width="11" height="11" />';
			}
		}
		$html .= '('.$ave.')';
	}

	//if ($_GET['mode'] === 'js') {
		// JavaScript出力
	//	@header('Content-Type: text/javascript; charset: utf-8');
	//	echo "document.write('{$html}');";
	//} elseif ($_GET['mode'] === 'php') {
		// php出力
		@header('Content-Type: text/html; charset: utf-8');
		echo $html;
	//}
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ ホスト取得
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function get_host() {
    $ref = (getenv("REMOTE_HOST")) ? getenv("REMOTE_HOST") : $_SERVER['REMOTE_HOST'];
    if ($ref == "") {
        $ip = (getenv("REMOTE_ADDR")) ? getenv("REMOTE_ADDR") : $_SERVER['REMOTE_ADDR'];
        $ref = gethostbyaddr($ip);
    }

	return $ref;
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ デコード
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function decode($str) {
	$str = mb_convert_encoding($str, "utf-8", "auto");
	//$str = mb_convert_encoding($str, "utf-8", mb_detect_encoding($str));
	$str = htmlspecialchars($str, ENT_QUOTES, "utf-8");
	$str = preg_replace("/\t/", " ", $str);
	$str = preg_replace("/\r\n|\n|\r/", "<br />", $str);

    return $str;
}

?>
